#pragma once

#include "RtmpPlatformCommon.h"
#include "RtmpPlatformUstream.h"
#include "RtmpPlatformLivestream.h"
#include "RtmpPlatformYouTubeLive.h"

typedef struct
{
    char type[128];
    char libname[128];
    RTMP_PLATFORM_FUNCTIONS *functions;
} RTMP_PLATFORM_BYTYPE;

typedef struct {
    char type[SMALL_STRING_LENGTH];
    char errorString[MEDIUM_STRING_LENGTH];
    union {
        UstreamConfig ustream;
        LivestreamConfig livestream;
        YouTubeLiveConfig ytl;
    } config;
} RtmpPlatform;

RtmpPlatform* RtmpPlatformCreate(char *type);
int RtmpPlatformConfig(RtmpPlatform *platform, char *configStr);
int RtmpPlatformPublish(RtmpPlatform *platform);
int RtmpPlatformCheck(RtmpPlatform *platform);
int RtmpPlatformStop(RtmpPlatform *platform);
int RtmpPlatformDestroy(RtmpPlatform **platform);
